; entferne-schrittweise.scm
; schrittweise Erarbeitung:

; Schritt 1: Kopf der Funktion
(define
  (entferne element liste)
  'undefiniert)

; Schritt 2: Element am Kopf der Liste gefunden.
(define
  (entferne element liste)
  (cond
    ((equal? element (car liste))
     (rest liste))
    (else
     'undefiniert)))
; Test zu 2:
(entferne 3 '(3 43 33 5.5 3 7))
(entferne 3 '(11 -2 3 43 33 5.5 3 7))

; Schritt 3: Element nicht am Kopf der Liste gefunden.
(define
  (entferne element liste)
  (cond
    ((equal? element (car liste))
     (rest liste))
    (else
     (cons (first liste) (entferne element (rest liste))))))
; Test zu 3:
(entferne 3 '(3 43 33 5.5 3 7))
(entferne 3 '(11 -2 3 43 33 5.5 3 7))


; Schritt 4: Element gar nicht in der Liste enthalten.
(define
  (entferne element liste)
  (cond
    ((null? liste) '())
    ((equal? element (car liste))
     (rest liste))
    (else
     (cons (first liste) (entferne element (rest liste))))))
; Test zu 4:
(entferne 3 '(3 43 33 5.5 3 7))
(entferne 3 '(11 -2 3 43 33 5.5 3 7))
(entferne 2 '(11 -2 3 43 33 5.5 3 7))

;; Schritt 4 - Alternative: Fehlermeldung
;(define
;  (entferne element liste)
;  (cond
;    ((null? liste)
;     (error (string-append
;             (number->string element)
;             " ist in der Liste nicht enthalten.")))
;    ((equal? element (car liste))
;     (rest liste))
;    (else
;     (cons (first liste) (entferne element (rest liste))))))
;; Test zu 4a:
;(entferne 3 '(3 43 33 5.5 3 7))
;(entferne 3 '(11 -2 3 43 33 5.5 3 7))
;(entferne 2 '(11 -2 3 43 33 5.5 3 7))
